



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>简述 JPA 与 Spring Data JPA 与 Hibernate</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">简述 JPA 与 Spring Data JPA 与 Hibernate</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 14:22:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>1.JPA是什么？以及相关概述</h3>
<ul><li>JPA的是 Java Persistence API 的简写，是Sun官方提出的一种ORM规范！</li>
<li>Sun提出此规范有2个原因：<br /><br />
1.简化现有Java EE和Java SE应用开发工作。<br /><br />
2.Sun希望整合ORM技术，实现天下归一。</li>
<li>重点在于，JPA是一套规范，而不是具体的ORM框架。</li>
<li>故Hibernate、TopLink 等ORM框架 都是JPA的实现，其中Hibernate已获得Sun的兼容认证。</li>
<li>JPA的标准的定制是hibernate作者参与定制的，所以JPA是Hibernate的一个总成。</li>
<li>优势在于：<br /><br />
1.开发者面向JPA规范的接口，但底层的JPA实现可以任意切换：觉得Hibernate好的，可以选择Hibernate JPA实现；觉得TopLink好的，可以选择TopLink JPA实现。<br /><br />
2.这样开发者可以避免为使用Hibernate学习一套ORM框架，为使用TopLink又要再学习一套ORM框架。</li>
<li>在项目中使用方式为：在实体类中，使用 <code>@Entity</code> 、 <code>@Table</code>  、<code>@Id</code> 与 <code>@Column</code> 等注解。</li>
<li>示例代码如下：</li></ul>
<pre class="prettyprint linenums"><code>import javax.persistence.*;<br />
import javax.persistence.Id;

@Entity<br />
@Table(name = &quot;t_user&quot;)//数据库中表名<br />
public class UserEO {<br />
    @Id<br />
    @Column(name = &quot;USER_ID&quot;)//数据库中字段名<br />
    private String userId;

    @Column(name = &quot;USER_NAME&quot;)<br />
    private String  userName;

}<br />
</code></pre>
<ul><li>jar包结构如下图所示：<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1331009/201802/1331009-20180222114222575-587956204.png"></li></ul>
<h3>2.Spring Data JPA是什么？以及相关概述</h3>
<ul><li>首先Spring框架几乎是无所不能，无所不在。</li>
<li>其次Spring也想要做持久化相关工作，并且已有Spring-data-**这一系列包（Spring-data-jpa,Spring-data-template,Spring-data-mongodb等）。</li>
<li>其中Spring-data-jpa即代表着，Spring框架对JPA的整合。</li>
<li>Spring Data JPA是在JPA规范的基础下提供了Repository层的实现。</li>
<li>在项目中的repository层中具体表现为：<br /><br />
1.接口要继承<code>JpaRepository</code>接口，示例代码如下：</li></ul>
<pre class="prettyprint linenums"><code>@Repository<br />
public interface UserRepository extends JpaRepository&lt;UserEO,String&gt;{//第二个参数是UserEO对应的表的主键类型

    //直接定义如下方法，不需要写具体的sql语句<br />
   List&lt;UserEO&gt; findByUserName(String userName);

    //对于自定义操作（比如更新状态字段为 ‘1’）使用 @Query注解<br />
    @Query(&quot;update UserEO u set u.status = '1' where u.userName = :userName<br />
    void updateStatusByName(String userName);

    //此方法 需要拼接条件  在实现类中重写<br />
     List&lt;UserEO&gt; findByUserName(Condition condition);

}<br />
</code></pre>
<p>2.实现类无需显式实现 <code>UserRepository</code>，只要命名为<code>UserRepositoryImpl</code>即可。<br /><br />
好处在于对于不需要写sql或者sql语句不复杂(使用 @Query 注解可以实现的)的方法，不用重写。<br /><br />
对于需要判断并拼接查询条件的方法，我们可以在实现类中进行重写。<br /><br />
示例代码如下：</p>
<pre class="prettyprint linenums"><code>public  List&lt;UserEO&gt; findByUserName(Condition condition) {<br />
    StringBuilder jpql = new StringBuilder(&quot; select u from userEO u where u.tatus = '1'  &quot; );

    if (StringUtils.hasText(conditon.getUserName)) {<br />
            jpql.append(&quot; and u.userName = :userName &quot; );<br />
     }<br />
    //执行 sql .. 返回List集合...<br />
}

</code></pre>
<ul><li><p>jar包结构如下图：<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1331009/201802/1331009-20180222131823516-405212279.png"></p></li>
<li><p>关于spring-data-jpa的使用可参考：<a href="https://www.cnblogs.com/dreamroute/p/5173896.html" rel="external nofollow noreferrer">https://www.cnblogs.com/dreamroute/p/5173896.html</a></p></li></ul>
<h3>3.总结</h3>
<ul><li>JPA是一套规范，Hibernate框架做了较好的实现。</li>
<li>Spring框架独揽了repository的实现，即CRUD相关操作，即 Spring Data JPA</li>
<li>JPA 对实体(xxxEO)操作，使其与数据库关联。</li>
<li>下面2图展示了JPA 与 ORM框架关系，以及 Spring Data JPA做了什么<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1331009/201802/1331009-20180222125641033-1636968052.png"><br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1331009/201802/1331009-20180222125651264-1858696834.png"></li></ul>
<h4>不知道为什么，突然就想更新下！2018年2月27日~</h4>
<p>从maven仓库搜索 'jpa' 的结果（下图）可以看到，JPA的非repository部分已经被Hibernate霸占了，可怕。<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1331009/201802/1331009-20180227091706542-88648690.png"></p>
<p>本文参考：<a href="http://www.lxway.com/528201191.htm" rel="external nofollow noreferrer">http://www.lxway.com/528201191.htm</a><br /><br />
<a href="https://www.cnblogs.com/dreamroute/p/5173896.html" rel="external nofollow noreferrer">https://www.cnblogs.com/dreamroute/p/5173896.html</a><br /><br />
<a href="http://www.cnblogs.com/xiaoheike/p/5150553.html" rel="external nofollow noreferrer">http://www.cnblogs.com/xiaoheike/p/5150553.html</a><br /><br />
<a href="https://baike.baidu.com/item/JPA/5660672?fr=aladdin" rel="external nofollow noreferrer">https://baike.baidu.com/item/JPA/5660672?fr=aladdin</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn5wd3q.html">&lpar;01-02&rpar; odoo8&period;0&lowbar;Ubuntu14&period;04&lowbar;nginx反代理设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq41penq.html">Lambda表达式动态拼接&lpar;备忘&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vm6z48.html">javascript实现prim算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm3xxz9.html">SPRING IN ACTION 第4版笔记-第十一章Persisting data with object-relational mapping-003编写JPA-based repository&lpar; &commat;PersistenceUnit、 &commat;PersistenceContext、PersistenceAnnotationBeanPostProcessor&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdednxv9.html">Django 1&period;6 最佳实践&colon; 如何设置django项目的设置&lpar;settings&period;py&rpar;和部署文件&lpar;requirements&period;txt&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydn2dxq.html">ubuntu 14&period;04 chromium&comma;firefox 怎样正确安装Adobe flash player</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmzwgk9.html">poj  3740 Easy Finding 精确匹配</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mexlnoq.html">POJ 3928 &amp;amp&semi;amp&semi; hdu 2492 &amp;amp&semi;amp&semi; Uva1428  PingPong 【树状数组】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg24je8.html">搞定！ iTunes 不能添加铃声进去</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge7ool8.html">python学习第七讲&comma;python中的数据类型&comma;列表&comma;元祖&comma;字典&comma;之元祖使用与介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllj276q.html">Ubuntu 16&period;04 上安装 PCL 1&period;8&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2e74j9.html">python3编写网络爬虫14-动态渲染页面爬取</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvy3lk8.html">框架源码系列十二：Mybatis源码之手写Mybatis</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1yno1q.html">22状态模式State</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e433jk9.html">repeter  控制一行中显示几条内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4377k9.html">学习笔记TF042&colon;TF&period;Learn、分布式Estimator、深度学习Estimator</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvz1wk8.html">myeclipse中配置spring xml自己主动提示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2w21j9.html">Rsync实现多台Windows工作电脑文件同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1mnwe9.html">Linux quotacheck失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kxwkwq.html">openURL调用其他程序&lpar;转&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvewvdy9.html">从零搭建 vue-cli 脚手架</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p1yljq.html">170530、java 迭代hashmap常用的三种方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emk1nk9.html">修改Yii2的默认语言language为中文zh-CN的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kozpn6q.html">C&num;读取xml文件指定节点下的值</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p1jveq.html">ES&lowbar;DEVOPS-1</a>
			</li>
						<li><a href="https://www.batexi.com/a/9531gov8.html">程序入口函数和glibc及C&plus;&plus;全局构造和析构</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv3ymgq.html">Andrew Ng机器学习公开课笔记 -- Generalized Linear Models</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vxp62q.html">CAD和GIS绘制图形分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjvo2vq.html">PAT 1075 PAT Judge&lbrack;比较&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2gyzd8.html">关于eval 与new Function 到底该选哪个&quest;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
